'use client';

import * as React from 'react';
import { useRouter } from 'next/navigation';
import { LoadingButton } from '@mui/lab';
import Box from '@mui/material/Box';
import Card from '@mui/material/Card';
import Divider from '@mui/material/Divider';
import Stack from '@mui/material/Stack';
import Typography from '@mui/material/Typography';
import { Plus as PlusIcon } from '@phosphor-icons/react/dist/ssr/Plus';
import { useTranslation } from 'react-i18next';

import { paths } from '@/paths';
import { logger } from '@/lib/default-logger';
import { toast } from '@/components/core/toaster';
import type { LessonType } from '@/components/dashboard/lesson_type/ILessonType';
import { LessonTypesFilters } from '@/components/dashboard/lesson_type/lesson-types-filters';
import type { Filters } from '@/components/dashboard/lesson_type/lesson-types-filters';
import { LessonTypesPagination } from '@/components/dashboard/lesson_type/lesson-types-pagination';
import { LessonTypesSelectionProvider } from '@/components/dashboard/lesson_type/lesson-types-selection-context';
import { LessonTypesTable } from '@/components/dashboard/lesson_type/lesson-types-table';
import FormLoading from '@/components/loading';

interface PageProps {
  searchParams: {
    email?: string;
    phone?: string;
    sortDir?: 'asc' | 'desc';
    status?: string;
    name?: string;
    visible?: string;
    type?: string;
    //
  };
}

export default function Page({ searchParams }: PageProps): React.JSX.Element {
  const { t } = useTranslation();
  const { email, phone, sortDir, status, name, visible, type } = searchParams;
  const router = useRouter();

  const [isLoadingAddPage, setIsLoadingAddPage] = React.useState<boolean>(false);
  const [lessonTypesData, setLessonTypesData] = React.useState<LessonType[]>([]);
  const sortedLessonTypes = applySort(lessonTypesData, sortDir);
  const filteredLessonTypes = applyFilters(sortedLessonTypes, {
    email,
    phone,
    status,
    name,
    type,
    visible,
    //
  });

  const reloadRows = () => {
    console.log('reload rows');
  };

  return (
    <Box
      sx={{
        maxWidth: 'var(--Content-maxWidth)',
        m: 'var(--Content-margin)',
        p: 'var(--Content-padding)',
        width: 'var(--Content-width)',
      }}
    >
      <Stack spacing={4}>
        <Stack direction={{ xs: 'column', sm: 'row' }} spacing={3} sx={{ alignItems: 'flex-start' }}>
          <Box sx={{ flex: '1 1 auto' }}>
            <Typography variant="h4">{t('Lesson Types')}</Typography>
          </Box>
          <Box sx={{ display: 'flex', justifyContent: 'flex-end' }}>
            <LoadingButton
              loading={isLoadingAddPage}
              onClick={(): void => {
                setIsLoadingAddPage(true);
                router.push(paths.dashboard.lesson_types.create);
              }}
              startIcon={<PlusIcon />}
              variant="contained"
            >
              {/* add new lesson type */}
              {t('dashboard.lessonTypes.add')}
            </LoadingButton>
          </Box>
        </Stack>
        <LessonTypesSelectionProvider lessonTypes={filteredLessonTypes}>
          <Card>
            <LessonTypesFilters
              filters={{ email, phone, status, name, visible, type }}
              fullData={lessonTypesData}
              sortDir={sortDir}
            />
            <Divider />
            <Box sx={{ overflowX: 'auto' }}>
              <LessonTypesTable reloadRows={reloadRows} rows={filteredLessonTypes} />
            </Box>
            <Divider />
            <LessonTypesPagination count={filteredLessonTypes.length + 100} page={0} />
          </Card>
        </LessonTypesSelectionProvider>
      </Stack>
    </Box>
  );
}

// Sorting and filtering has to be done on the server.

function applySort(row: LessonType[], sortDir: 'asc' | 'desc' | undefined): LessonType[] {
  return row.sort((a, b) => {
    if (sortDir === 'asc') {
      return a.createdAt.getTime() - b.createdAt.getTime();
    }

    return b.createdAt.getTime() - a.createdAt.getTime();
  });
}

function applyFilters(row: LessonType[], { email, phone, status, name, visible }: Filters): LessonType[] {
  return row.filter((item) => {
    if (email) {
      if (!item.email?.toLowerCase().includes(email.toLowerCase())) {
        return false;
      }
    }

    if (phone) {
      if (!item.phone?.toLowerCase().includes(phone.toLowerCase())) {
        return false;
      }
    }

    if (status) {
      if (item.status !== status) {
        return false;
      }
    }

    if (name) {
      if (!item.name?.toLowerCase().includes(name.toLowerCase())) {
        return false;
      }
    }

    if (visible) {
      if (!item.visible?.toLowerCase().includes(visible.toLowerCase())) {
        return false;
      }
    }

    return true;
  });
}
